'--------------------------------------------------------------------------------------------------
' Name         : Ozi2TNCclimb.VBS
' Version      : 0.90 vom 31.03.07
' Author       : Michael Burger
' Beschreibung : VBScript zum ferngesteuerten Import von Wegpunkten aus Dateien 
'                im Format Ozi-Explorer V1.1 in TN Complete
'--------------------------------------------------------------------------------------------------


' ACHTUNG !!!!!!!!
' Aus irgend einem seltsamen Grund klappt es nicht, das originale Programm zu starten.
' Ich habe einfach eine Verknpfung zu "TN Complete.exe" angelegt mit dem Namen "tnc"
' Bitte einfach genauso vorgehen und dann den Pfad entsprechend anpassen

tnc="C:\Programme\Aircotec\TNComplete\tnc" 
tempfile="C:\WINDOWS\Temp\ozi2tnc_tempfile"
defaultcode="DE"
defaultlonbase="E"
defaultlatbase="N"
defaultwindspeed=5
'--------------------------------------------------------------------------------------------------

'23 .... Zuerst brauchen wir mal ein Scripting-Objekt
set ws = CreateObject("Wscript.shell")


'27.... Falls TNC gerade luft, beenden wir es erst mal
ws.AppActivate "TN Complete"
ws.sendkeys("%{F4}")

'31.... Kurz warten und so lange etwas anzeigen ...
ws.popup "Ozi2TNCclimb V0.90  (c) Michael Burger",2,"Ozi2TNCclimb"

'34.... Den Benutzer nach der Waypoint-Datei fragen und warten, bis er fertig ist
set fs = CreateObject("Scripting.FileSystemObject")

if fs.fileExists(tempfile) then
  Set f1 = fs.GetFile(tempfile)
  f1.Delete
end if

ws.run("fopen.exe Select_Ozi_File_to_Open")
do 
  wscript.sleep 100
loop until fs.fileExists(tempfile)


'48.... Dateiname ermitteln und ggfs abbrechen
set dateiinhalt = fs.opentextfile(tempfile)
dateiname = dateiname & dateiinhalt.readline
dateiinhalt.close
if len(dateiname) <5 then WScript.Quit


'55.... Prfen, ob es wirklich eine Ozi 1.1 Datei ist
set dateiinhalt = fs.opentextfile(dateiname)
erstezeile = erstezeile & dateiinhalt.readline
if StrComp(erstezeile,"OziExplorer Waypoint File Version 1.1") then
   dateiinhalt.close   
   MsgBox "! FEHLER: Keine OziExplorer V1.1 Datei !",vbCritical,"Ozi2TNCclimb-FEHLER"
   WScript.Quit
end if 


'65.... 3 Zeilen berspringen
if not dateiinhalt.AtEndOfStream then dateiinhalt.readline
if not dateiinhalt.AtEndOfStream then dateiinhalt.readline
if not dateiinhalt.AtEndOfStream then dateiinhalt.readline
if dateiinhalt.AtEndOfStream then
   dateiinhalt.close   
   MsgBox "! FEHLER: Unerwartetes Dateiende !",vbCritical,"Ozi2TNCclimb-FEHLER"
   WScript.Quit
end if 

'75.... Abfragen des 2 Zeichen langen Codes
do
lcode = inputbox("Bitte den (Lnder-)Code eingeben (2 Character): ", "Code Input", defaultcode)
if lcode = cancel then 
   dateiinhalt.close   
   wscript.quit
end if
loop until len(lcode) =2
frage= UCase(lcode)

'85.... Abfragen des Startwertes zum Durchnummerieren
do
startwert = inputbox("Startwert fr fortlaufende Nummer eingeben.    Max. 3 digits !", "Enumeration Start", "1")
if  startwert= cancel then 
   dateiinhalt.close   
   wscript.quit
end if
loop until startwert >0 and startwert <1000


'95.... TNC wieder starten und kurz warten
ws.run(tnc)
wscript.sleep 1500
ws.AppActivate "TN Complete"
wscript.sleep 500


'102.... Mit Strg+d das Datenbankfenster ffnen und wieder kurz warten
ws.sendkeys("^d")
wscript.sleep 500


'107.... Mit Alt+u in den Tab Aufwind wechseln und kurz warten
ws.sendkeys("%u")
wscript.sleep 500


'115.... AB HIER LUFT DIE SCHLEIFE, IN DER DIE WEGPUNKTE VERARBEITET WERDEN
do
  zeile=dateiinhalt.readline

'119.... Windrichtung aus der T2T-Bezeichnung extrahieren
  t2twind=mid(zeile,7,1)
  Select Case t2twind
     Case "N","n":
       wind=0 
     Case "E","e":
       wind=90
     Case "S","s":
       wind=180
     Case "W","w":
       wind=270
     Case Else:
       wind=0
  End Select
  

'135.... Steigrate aus der T2T-Bezeichnung extrahieren
  t2tclimb=mid(zeile,8,1)
  Select Case t2tclimb
     Case 0:
       climb=0.2 
     Case 1:
       climb=1.1
     Case 2,3,4,5,6,7,8,9:
       climb=t2tclimb-0.1
     Case Else:
       climb=0
  End Select
  

'149.... Hhe aus der T2T-Bezeichnung extrahieren
  height=mid(zeile,9,3)*10

'153.... Longitude und Latitude lesen und umrechnen
  latdec=replace(mid(zeile,22,10),".",",")
  latdeg=Fix(latdec)
  latmin=replace(round((latdec-latdeg)*60,3),",",".")

  londec=replace(mid(zeile,34,10),".",",")
  londeg=Fix(londec)
  lonmin=replace(round((londec-londeg)*60,3),",",".")

'162.... Dialog fr neuen Datensatz in TN Complete ausfllen
  ws.sendkeys("%n")
  wscript.sleep 100

  ws.sendkeys(lcode)
  ws.sendkeys("{TAB}")

'169.... "Name" mit fhrenden Nullen
  count=3-len(startwert)
  if count >0 then
    while (count>0)
      ws.sendkeys("0")
      count=count-1
    wend
  end if
  ws.sendkeys(startwert)
  startwert=startwert+1
  ws.sendkeys("{TAB}")

'181.... Latitude
  ws.sendkeys(defaultlatbase)
  count=2-len(latdeg)
  if count >0 then
    while (count>0)
      ws.sendkeys("0")
      count=count-1
    wend
  end if
  ws.sendkeys(latdeg)
  ws.sendkeys(latmin)
  count=6-len(latmin)
  if count >0 then
    while (count>0)
      ws.sendkeys("0")
      count=count-1
    wend
  end if
  
'200.... Longitude
  ws.sendkeys(defaultlonbase)
  count=3-len(londeg)
  if count >0 then
    while (count>0)
      ws.sendkeys("0")
      count=count-1
    wend
  end if
  ws.sendkeys(londeg)
  ws.sendkeys(lonmin)
  count=6-len(lonmin)
  if count >0 then
    while (count>0)
      ws.sendkeys("0")
      count=count-1
    wend
  end if
  
'219.... Hhe
  count=4-len(height)
  if count >0 then
    while (count>0)
      ws.sendkeys("0")
      count=count-1
    wend
  end if
  ws.sendkeys(height)

'219.... Steigen
  count=4-len(climb)
  if count >0 then
    while (count>0)
      ws.sendkeys("0")
      count=count-1
    wend
  end if
  ws.sendkeys(climb)

'29.... Windgeschwindigkeit
  count=3-len(defaultwindspeed)
  if count >0 then
    while (count>0)
      ws.sendkeys("0")
      count=count-1
    wend
  end if
  ws.sendkeys(defaultwindspeed)

'239.... Windrichtung
  count=3-len(wind)
  if count >0 then
    while (count>0)
      ws.sendkeys("0")
      count=count-1
    wend
  end if
  ws.sendkeys(wind)
  
'259.... Kommentar
  ws.sendkeys("T2T Waypoint coverted by Ozi2TNCclimb")

'262.... Und zum Absenden die Enter-Taste
  ws.sendkeys("{ENTER}")
  wscript.sleep 100

loop until dateiinhalt.AtEndOfStream

dateiinhalt.close   
MsgBox "Fertig: ",vbInformation,"Ozi2TNCclimb-Info"
WScript.Quit 









